"""The validate plugin module."""
# NOTE: It is safe to edit this file.
# This file is only initially generated by aac gen-plugin, and it won't be overwritten if the file already exists.

from aac.cli.aac_command import AacCommand, AacCommandArgument
from aac.cli.builtin_commands.validate.validate_impl import validate
from aac.plugins import hookimpl
from aac.plugins.plugin import Plugin


@hookimpl
def get_plugin() -> Plugin:
    """
    Returns information about the plugin.

    Returns:
        A collection of information about the plugin and what it contributes.
    """
    *_, plugin_name = __package__.split(".")
    plugin = Plugin(plugin_name)
    plugin.register_commands(_get_plugin_commands())
    return plugin


def _get_plugin_commands():
    validate_arguments = [
        AacCommandArgument(
            "architecture_file",
            "The path to the AaC file to be validated.",
            data_type="file",
        ),
        AacCommandArgument(
            "--definition_name",
            """The name of one definition to validate. (optional)
            This argument will cause only the definition provided by the argument to be validated.""",
            data_type="str",
        ),
    ]

    plugin_commands = [
        AacCommand(
            "validate",
            "Validate the AaC definition file.",
            validate,
            validate_arguments
        ),
    ]

    return plugin_commands
