"""The help-dump plugin module."""
# NOTE: It is safe to edit this file.
# This file is only initially generated by aac gen-plugin, and it won't be overwritten if the file already exists.

from aac.cli.aac_command import AacCommand
from aac.plugins import hookimpl
from aac.plugins.plugin import Plugin
from aac.plugins.help_dump.help_dump_impl import help_dump


@hookimpl
def get_plugin() -> Plugin:
    """
    Returns information about the plugin.

    Returns:
        A collection of information about the plugin and what it contributes.
    """
    *_, plugin_name = __package__.split(".")
    plugin = Plugin(plugin_name)
    plugin.register_commands(_get_plugin_commands())
    return plugin


def _get_plugin_commands():
    plugin_commands = [
        AacCommand(
            "help-dump",
            "Produce a formatted string containing all commands, their arguments, and each of their descriptions.",
            help_dump,
        ),
    ]

    return plugin_commands
